import sys

import pygame

from bombz import appdir

OUTER_FONT_SIZE = 28
INNER_FONT_SIZE = 26
OUTER_COLOUR = (0, 0, 0)
INNER_COLOUR = (255, 255, 0)
DANGER_COLOUR = (255, 0, 0)

digits = [None] * 10
danger_digits = [None] * 10
colon = None
danger_colon = None

widest = 0
highest = 0

def create_font(size):
	return pygame.font.Font(appdir.get_font_filename(), size)

def create_glyph(outer_font, inner_font, s, colour = INNER_COLOUR):
	outer_surf = outer_font.render(s, True, OUTER_COLOUR).convert_alpha()
	ow = outer_surf.get_width()
	oh = outer_surf.get_height()
	inner_surf = inner_font.render(s, True, colour).convert_alpha()
	iw = inner_surf.get_width()
	ih = inner_surf.get_height()
	outer_surf.blit(inner_surf, (int((ow - iw) / 2), int((oh - ih) / 2)))
	return outer_surf

def get_digit_size():
	global digits, widest, highest
	if not widest or not highest:
		for d in range(10):
			w = digits[d].get_width()
			h = digits[d].get_height()
			"""
			if d > 0 and (w != widest or h != highest):
				print >> sys.stderr, \
						_("Digit %d has different glyph size %dx%d from " \
						"previous biggest %dx%d") % (d, w, h, widest, highest)
			"""
			if w > widest:
				widest = w
			if h > highest:
				highest = h
	return (widest, highest)

def init():
	global digits, danger_digits, colon, danger_colon
	outer_font = create_font(OUTER_FONT_SIZE)
	outer_font.set_bold(True)
	inner_font = create_font(INNER_FONT_SIZE)
	for d in range(10):
		digits[d] = create_glyph(outer_font, inner_font, '%c' % (ord('0') + d))
		danger_digits[d] = create_glyph(outer_font, inner_font,
			'%c' % (ord('0') + d), DANGER_COLOUR)
	colon = create_glyph(outer_font, inner_font, ':')
	danger_colon = create_glyph(outer_font, inner_font, ':', DANGER_COLOUR)
