import pygame

up1 = pygame.K_UP
up2 = pygame.K_l
down1 = pygame.K_DOWN
down2 = pygame.K_COMMA
left1 = pygame.K_LEFT
left2 = pygame.K_z
right1 = pygame.K_RIGHT
right2 = pygame.K_x

def interpret_event(e):
	""" Returns [is_key_event (bool), [x, y], action, back] """
	global up1, down1, left1, right1, up2, down2, left2, right2
	if e.type == pygame.KEYDOWN:
		if e.key == pygame.K_RETURN or e.key == pygame.K_SPACE:
			return [True, [0, 0], True, False]
		if e.key == pygame.K_ESCAPE:
			return [True, [0, 0], False, True]
		if e.key == up1 or e.key == up2:
			return [True, [0, -1], False, False]
		if e.key == down1 or e.key == down2:
			return [True, [0, 1], False, False]
		if e.key == left1 or e.key == left2:
			return [True, [-1, 0], False, False]
		if e.key == right1 or e.key == right2:
			return [True, [1, 0], False, False]
	return [False, [0, 0], False, False]

def get_direction():
	""" Checks the state of the direction keys and returns bools [l, r, u, d]
	"""
	global up1, down1, left1, right1, up2, down2, left2, right2
	result = [False, False, False, False]
	pressed = pygame.key.get_pressed()
	if pressed[left1] or pressed[left2]:
		result[0] = True
	if pressed[right1] or pressed[right2]:
		result[1] = True
	if pressed[up1] or pressed[up2]:
		result[2] = True
	if pressed[down1] or pressed[down2]:
		result[3] = True
	return result

def oofy(desc, k):
	print "%s %d %s" % (desc, k, pygame.key.name(k))

def init(opts):
	global up2, down2, left2, right2
	up2 = int(opts.lookup("k_up", pygame.K_l))
	down2 = int(opts.lookup("k_down", pygame.K_COMMA))
	left2 = int(opts.lookup("k_left", pygame.K_z))
	right2 = int(opts.lookup("k_right", pygame.K_x))
