import os

import pygame

from bombz import appdir

pip1 = None
pip2 = None
bomb = None
match = None
fuse = None

# pygame.mixer doesn't necessarily interrupt old sounds with new ones
# so need to make a ChannelManager to deal with that
class ChannelManager:
	def __init__(self):
		self.n_channels = pygame.mixer.get_num_channels()
		self.channels = []
	
	def play(self, sound, loops = 0, maxtime = 0):
		chan = pygame.mixer.find_channel()
		if not chan:
			chan = self.channels[0]
			chan.stop()
		# Move this channel to end of list so it will be last to get interrupted
		if chan in self.channels:
			self.channels.remove(chan)
		self.channels.append(chan)
		chan.play(sound, loops, maxtime)
		
channel_manager = None

class Sound(pygame.mixer.Sound):
	def play(self, loops = 0, maxtime = 0):
		global channel_manager
		channel_manager.play(self, loops, maxtime)

def load_sound_file(name):
	return Sound(os.path.join(appdir.get_sounds_dir(), name))

def load_wav(name):
	return load_sound_file(name + '.wav')

def init():
	global pip1, pip2, bomb, match, fuse
	global channel_manager 
	channel_manager = ChannelManager()
	pip1 = load_wav("pip1")
	pip2 = load_wav("pip2")
	bomb = load_wav("bomb")
	match = load_wav("match")
	fuse = load_wav("fuse")

